import fs from "fs"
import path_lib from "path"

export class File {
	constructor({ host, path }) {
		this.onConnect = null;
		this.onDisconnect = null;
		this.onMessage = null;
		this.path = host || path;
		try {
			// create directory if it doesn't exist
			if (!fs.existsSync(this.path)){
				fs.mkdirSync(path_lib.dirname(this.path), {recursive: true})
				// touch the file
				try {
					time = new Date()
					fs.utimesSync(this.path, time, time);
				} catch (err) {
					fs.closeSync(fs.openSync(this.path, 'w'));
				}
			}
		} catch (error) {
			console.error("Unable to create path ", this.path);
			throw error;
		}
	}

	destroy(){
		return;
	}

	connect() {
		if (this.onConnect) this.onConnect();
	}

	disconnect() {
		if (this.onDisconnect) this.onDisconnect();
	}

	send(data, next) {
		if (!next) { next = () => { } }
		try {
			fs.appendFileSync(this.path, JSON.stringify(data) + "\n", {
				encoding: "utf8"
			});
			next()
		} catch (error) {
			console.error(error);
			next(error)
		}
	}
}
