// help function to get degree on tracking_resolutions
export function getDegree(line) {
	let regex = /(\d{1,5}(deg|rad))/gm;
	let resp = regex.exec(line);
	if (resp && resp[0]) return resp[0].trim();
	else return null;
}

// help function to get distance on tracking_resolutions
export function getDistance(line) {
	let regex = /(\d{1,5}(mts|km|kms|mile))/gm;
	let resp = regex.exec(line);
	if (resp && resp[0]) return resp[0].trim();
	else return null;
}

// help function to get time on tracking_resolutions
export function getTime(line) {
	let regex = /(\d{1,5}(hr|min|sec|s|h|m+$|m[^t]))/gm;
	let resp = regex.exec(line);
	if (resp && resp[0] && resp[0].endsWith("s")) console.warn(`${resp[0]} is now deprecated you should use 'sec' as unit`);
	if (resp && resp[0] && resp[0].endsWith("m")) console.warn(`${resp[0]} is now deprecated you should use 'min' as unit`);
	if (resp && resp[0] && resp[0].endsWith("h")) console.warn(`${resp[0]} is now deprecated you should use 'hr' as unit`);
	if (resp && resp[0]) return resp[0].trim();
	else return null;
}

// helper function to get csv pair like $ecu:$ecu,foo:bar as { "$ecu": "$ecu", "foo": "bar"}
// easy to handle for javascript, ej: fieldset use this config, also headers for mqtt and http
export function getAsCSVPair(val) {
	var results = {};
	var pairs = val.split(",");
	pairs.forEach(txt => {
		results[txt.split(":")[0]] = txt.split(":")[1];
	});
	return results;
}
