// Helper function to construct IX= extended tag
export function getIO(data) {
	let byte1 = "1";
	let byte2 = `${data["$io.ign"]}` == "true" ? 2 : 0;
	byte2 += `${data["$io.pwr"]}` == "true" ? 1 : 0;
	let byte3 = `${data["$io.in1"]}` == "true" ? 1 : 0;
	byte3 += `${data["$io.in2"]}` == "true" ? 2 : 0;
	byte3 += `${data["$io.in3"]}` == "true" ? 4 : 0;
	let byte4 = `${data["$io.out1"]}` == "true" ? 1 : 0;
	byte4 += `${data["$io.out2"]}` == "true" ? 2 : 0;

	// Extendeds
	let byte5 = `${data["$io.so1"]}` == "true" || `${data["$io.so2"]}` == "true" ? 1 : 0;
	let byte6 = `${data["$io.in4"]}` == "true" ? 1 : 0;
	byte6 += `${data["$io.in5"]}` == "true" ? 2 : 0;
	byte6 += `${data["$io.in6"]}` == "true" ? 4 : 0;
	byte6 += `${data["$io.in7"]}` == "true" ? 8 : 0;
	let byte7 = `${data["$io.out3"]}` == "true" ? 1 : 0;
	byte7 += `${data["$io.out4"]}` == "true" ? 2 : 0;
	let byte8 = `${data["$io.so3"]}` == "true" || `${data["$io.so4"]}` == "true" ? 1 : 0;
	return `;IX=1${byte1}2${byte2}3${byte3}4${byte4}5${byte5}6${byte6}7${byte7}8${byte8}`;
}

// Helper function to construct AW= extended tag
export function getAnalogs(data) {
	let AD = "";
	let an1 = parseInt(data["$io.an1"]) || 0
	let an2 = parseInt(data["$io.an2"]) || 0
	let d12 = parseInt(data["$io.dan"]) || 0
	if (an1) AD = `;AD=${an1}`
	return `${AD};AW=${an1},${an2},,,,,,,${d12},,,,,,,`;
}

