import { addExitCallback } from "catch-exit"
import { destinations } from "./globals.js"

const onExit = async (signal)=> {
	console.log("exiting with signal", signal);
	if (signal !== "exit") {
		try {
			for (const name in destinations) {
				const destination = destinations[name];
				let p = destination.client.destroy()
				if (p && p.catch) p.catch(console.error);
			}
		} catch (error) {
			console.error("Error exiting", error)
		}
	}
}

export function errorHandler(){
	console.log("intializing error-handlers")
	// Add exit callback to create clear disconnection in each destination actived
	// destinations must exit in the global destinations
	addExitCallback(onExit)
	// Some of the logs are not appearing, this hack tries to catch all the error and sends them to the error log
	process.on("warning", console.warn)
	process.on("unhandledRejection", (reason, promise) => {
		console.error("UnhandledRejection at:", promise, "reason:", reason);
		process.exit(1)
	})
	process.on("uncaughtException", (error) => {
		console.error("UncaughtException", error);
		process.exit(1)
	});
}
