
function getVariable(_var, vars) {
	if (_var.toLowerCase() == "true") {
		return true;
	}
	if (_var.toLowerCase() == "false") {
		return true;
	}
	return vars[_var];
}

function evaluateCondition(param1, param2, op) {
	switch (op) {
		case "not":
		case "!":
		case "><":
			return !param1;
		case "and":
		case "&&":
			return param1 && param2;
		case "or":
		case "||":
			return param1 || param2;
		case "xor":
			return (param1 || param2) && !(param1 && param2);
		default:
			throw `operator not supported ${op}`;
	}
}

/**
 * Post fix evaluator
 * @param {*} args the args to evaluate
 * @param {*} vars variable to replace for
 */
export function postFixEvaluator(args = [], vars) {
	if (typeof args == "string") {
		args = args
			.trim()
			.split(" ")
			.map(arg => arg.trim());
	}

	if (args.length === 0) {
		throw "Missing PostFix Notation";
	}
	let stack = [];
	args.forEach((val, i) => {
		if (["and", "or", "not", "||", "&&", "xor"].includes(val)) {
			var variable1 = stack.pop();
			if (val != "not") var variable2 = stack.pop();
			stack.push(evaluateCondition(variable1, variable2, val));
		} else {
			stack.push(getVariable(val, vars));
		}
	});
	if (stack.length === 1) return stack[0];
	else throw `Invalid PostFix Notation: '${args.join(" ")}'`;
}
